!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(require("codemirror")):"function"==typeof define&&define.amd?define(["codemirror"],e):e((t=t||self).CodeMirror)}(this,(function(t){"use strict";
/**
   * A specialized version of `_.map` for arrays without support for iteratee
   * shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns the new mapped array.
   */var e=function(t,e){for(var n=-1,r=null==t?0:t.length,o=Array(r);++n<r;)o[n]=e(t[n],n,t);return o};
/**
   * Removes all key-value entries from the list cache.
   *
   * @private
   * @name clear
   * @memberOf ListCache
   */var n=function(){this.__data__=[],this.size=0};
/**
   * Performs a
   * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
   * comparison between two values to determine if they are equivalent.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to compare.
   * @param {*} other The other value to compare.
   * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
   * @example
   *
   * var object = { 'a': 1 };
   * var other = { 'a': 1 };
   *
   * _.eq(object, object);
   * // => true
   *
   * _.eq(object, other);
   * // => false
   *
   * _.eq('a', 'a');
   * // => true
   *
   * _.eq('a', Object('a'));
   * // => false
   *
   * _.eq(NaN, NaN);
   * // => true
   */var r=function(t,e){return t===e||t!=t&&e!=e};
/**
   * Gets the index at which the `key` is found in `array` of key-value pairs.
   *
   * @private
   * @param {Array} array The array to inspect.
   * @param {*} key The key to search for.
   * @returns {number} Returns the index of the matched value, else `-1`.
   */var o=function(t,e){for(var n=t.length;n--;)if(r(t[n][0],e))return n;return-1},i=Array.prototype.splice;
/** Used for built-in method references. */var a=
/**
   * Removes `key` and its value from the list cache.
   *
   * @private
   * @name delete
   * @memberOf ListCache
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */
function(t){var e=this.__data__,n=o(e,t);return!(n<0)&&(n==e.length-1?e.pop():i.call(e,n,1),--this.size,!0)};
/**
   * Gets the list cache value for `key`.
   *
   * @private
   * @name get
   * @memberOf ListCache
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */var c=function(t){var e=this.__data__,n=o(e,t);return n<0?void 0:e[n][1]};
/**
   * Checks if a list cache value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf ListCache
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */var u=function(t){return o(this.__data__,t)>-1};
/**
   * Sets the list cache `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf ListCache
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the list cache instance.
   */var s=function(t,e){var n=this.__data__,r=o(n,t);return r<0?(++this.size,n.push([t,e])):n[r][1]=e,this};
/**
   * Creates an list cache object.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */function l(t){var e=-1,n=null==t?0:t.length;for(this.clear();++e<n;){var r=t[e];this.set(r[0],r[1])}}// Add methods to `ListCache`.
l.prototype.clear=n,l.prototype.delete=a,l.prototype.get=c,l.prototype.has=u,l.prototype.set=s;var f=l;
/**
   * Removes all key-value entries from the stack.
   *
   * @private
   * @name clear
   * @memberOf Stack
   */var v=function(){this.__data__=new f,this.size=0};
/**
   * Removes `key` and its value from the stack.
   *
   * @private
   * @name delete
   * @memberOf Stack
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */var h=function(t){var e=this.__data__,n=e.delete(t);return this.size=e.size,n};
/**
   * Gets the stack value for `key`.
   *
   * @private
   * @name get
   * @memberOf Stack
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */var p=function(t){return this.__data__.get(t)};
/**
   * Checks if a stack value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf Stack
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */var d=function(t){return this.__data__.has(t)},g="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function b(t,e){return t(e={exports:{}},e.exports),e.exports
/** Detect free variable `global` from Node.js. */}var y="object"==typeof g&&g&&g.Object===Object&&g,_="object"==typeof self&&self&&self.Object===Object&&self,j=y||_||Function("return this")(),m=j.Symbol,k=Object.prototype,O=k.hasOwnProperty,w=k.toString,x=m?m.toStringTag:void 0;var A=
/**
   * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
   *
   * @private
   * @param {*} value The value to query.
   * @returns {string} Returns the raw `toStringTag`.
   */
function(t){var e=O.call(t,x),n=t[x];try{t[x]=void 0;var r=!0}catch(t){}var o=w.call(t);return r&&(e?t[x]=n:delete t[x]),o},M=Object.prototype.toString;
/** Used for built-in method references. */var S=
/**
   * Converts `value` to a string using `Object.prototype.toString`.
   *
   * @private
   * @param {*} value The value to convert.
   * @returns {string} Returns the converted string.
   */
function(t){return M.call(t)},P=m?m.toStringTag:void 0;
/** `Object#toString` result references. */var E=
/**
   * The base implementation of `getTag` without fallbacks for buggy environments.
   *
   * @private
   * @param {*} value The value to query.
   * @returns {string} Returns the `toStringTag`.
   */
function(t){return null==t?void 0===t?"[object Undefined]":"[object Null]":P&&P in Object(t)?A(t):S(t)};
/**
   * Checks if `value` is the
   * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
   * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an object, else `false`.
   * @example
   *
   * _.isObject({});
   * // => true
   *
   * _.isObject([1, 2, 3]);
   * // => true
   *
   * _.isObject(_.noop);
   * // => true
   *
   * _.isObject(null);
   * // => false
   */var T=function(t){var e=typeof t;return null!=t&&("object"==e||"function"==e)};
/** `Object#toString` result references. */var C,F=
/**
   * Checks if `value` is classified as a `Function` object.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a function, else `false`.
   * @example
   *
   * _.isFunction(_);
   * // => true
   *
   * _.isFunction(/abc/);
   * // => false
   */
function(t){if(!T(t))return!1;// The use of `Object#toString` avoids issues with the `typeof` operator
// in Safari 9 which returns 'object' for typed arrays and other constructors.
var e=E(t);return"[object Function]"==e||"[object GeneratorFunction]"==e||"[object AsyncFunction]"==e||"[object Proxy]"==e},z=j["__core-js_shared__"],L=(C=/[^.]+$/.exec(z&&z.keys&&z.keys.IE_PROTO||""))?"Symbol(src)_1."+C:"";
/** Used to detect overreaching core-js shims. */var I=
/**
   * Checks if `func` has its source masked.
   *
   * @private
   * @param {Function} func The function to check.
   * @returns {boolean} Returns `true` if `func` is masked, else `false`.
   */
function(t){return!!L&&L in t},R=Function.prototype.toString;
/** Used for built-in method references. */var $=
/**
   * Converts `func` to its source code.
   *
   * @private
   * @param {Function} func The function to convert.
   * @returns {string} Returns the source code.
   */
function(t){if(null!=t){try{return R.call(t)}catch(t){}try{return t+""}catch(t){}}return""},B=/^\[object .+?Constructor\]$/,W=Function.prototype,U=Object.prototype,N=W.toString,D=U.hasOwnProperty,V=RegExp("^"+N.call(D).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");
/**
   * Used to match `RegExp`
   * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
   */var q=
/**
   * The base implementation of `_.isNative` without bad shim checks.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a native function,
   *  else `false`.
   */
function(t){return!(!T(t)||I(t))&&(F(t)?V:B).test($(t))};
/**
   * Gets the value at `key` of `object`.
   *
   * @private
   * @param {Object} [object] The object to query.
   * @param {string} key The key of the property to get.
   * @returns {*} Returns the property value.
   */var G=function(t,e){return null==t?void 0:t[e]};
/**
   * Gets the native function at `key` of `object`.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {string} key The key of the method to get.
   * @returns {*} Returns the function if it's native, else `undefined`.
   */var H=function(t,e){var n=G(t,e);return q(n)?n:void 0},J=H(j,"Map"),K=H(Object,"create");
/* Built-in method references that are verified to be native. */var Q=
/**
   * Removes all key-value entries from the hash.
   *
   * @private
   * @name clear
   * @memberOf Hash
   */
function(){this.__data__=K?K(null):{},this.size=0};
/**
   * Removes `key` and its value from the hash.
   *
   * @private
   * @name delete
   * @memberOf Hash
   * @param {Object} hash The hash to modify.
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */var X=function(t){var e=this.has(t)&&delete this.__data__[t];return this.size-=e?1:0,e},Y=Object.prototype.hasOwnProperty;
/** Used to stand-in for `undefined` hash values. */var Z=
/**
   * Gets the hash value for `key`.
   *
   * @private
   * @name get
   * @memberOf Hash
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */
function(t){var e=this.__data__;if(K){var n=e[t];return"__lodash_hash_undefined__"===n?void 0:n}return Y.call(e,t)?e[t]:void 0},tt=Object.prototype.hasOwnProperty;
/** Used for built-in method references. */var et=
/**
   * Checks if a hash value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf Hash
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */
function(t){var e=this.__data__;return K?void 0!==e[t]:tt.call(e,t)};
/** Used to stand-in for `undefined` hash values. */var nt=
/**
   * Sets the hash `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf Hash
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the hash instance.
   */
function(t,e){var n=this.__data__;return this.size+=this.has(t)?0:1,n[t]=K&&void 0===e?"__lodash_hash_undefined__":e,this};
/**
   * Creates a hash object.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */function rt(t){var e=-1,n=null==t?0:t.length;for(this.clear();++e<n;){var r=t[e];this.set(r[0],r[1])}}// Add methods to `Hash`.
rt.prototype.clear=Q,rt.prototype.delete=X,rt.prototype.get=Z,rt.prototype.has=et,rt.prototype.set=nt;var ot=rt;
/**
   * Removes all key-value entries from the map.
   *
   * @private
   * @name clear
   * @memberOf MapCache
   */var it=function(){this.size=0,this.__data__={hash:new ot,map:new(J||f),string:new ot}};
/**
   * Checks if `value` is suitable for use as unique object key.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
   */var at=function(t){var e=typeof t;return"string"==e||"number"==e||"symbol"==e||"boolean"==e?"__proto__"!==t:null===t};
/**
   * Gets the data for `map`.
   *
   * @private
   * @param {Object} map The map to query.
   * @param {string} key The reference key.
   * @returns {*} Returns the map data.
   */var ct=function(t,e){var n=t.__data__;return at(e)?n["string"==typeof e?"string":"hash"]:n.map};
/**
   * Removes `key` and its value from the map.
   *
   * @private
   * @name delete
   * @memberOf MapCache
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */var ut=function(t){var e=ct(this,t).delete(t);return this.size-=e?1:0,e};
/**
   * Gets the map value for `key`.
   *
   * @private
   * @name get
   * @memberOf MapCache
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */var st=function(t){return ct(this,t).get(t)};
/**
   * Checks if a map value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf MapCache
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */var lt=function(t){return ct(this,t).has(t)};
/**
   * Sets the map `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf MapCache
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the map cache instance.
   */var ft=function(t,e){var n=ct(this,t),r=n.size;return n.set(t,e),this.size+=n.size==r?0:1,this};
/**
   * Creates a map cache object to store key-value pairs.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */function vt(t){var e=-1,n=null==t?0:t.length;for(this.clear();++e<n;){var r=t[e];this.set(r[0],r[1])}}// Add methods to `MapCache`.
vt.prototype.clear=it,vt.prototype.delete=ut,vt.prototype.get=st,vt.prototype.has=lt,vt.prototype.set=ft;var ht=vt;
/** Used as the size to enable large array optimizations. */var pt=
/**
   * Sets the stack `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf Stack
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the stack cache instance.
   */
function(t,e){var n=this.__data__;if(n instanceof f){var r=n.__data__;if(!J||r.length<199)return r.push([t,e]),this.size=++n.size,this;n=this.__data__=new ht(r)}return n.set(t,e),this.size=n.size,this};
/**
   * Creates a stack cache object to store key-value pairs.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */function dt(t){var e=this.__data__=new f(t);this.size=e.size}// Add methods to `Stack`.
dt.prototype.clear=v,dt.prototype.delete=h,dt.prototype.get=p,dt.prototype.has=d,dt.prototype.set=pt;var gt=dt;
/** Used to stand-in for `undefined` hash values. */var bt=
/**
   * Adds `value` to the array cache.
   *
   * @private
   * @name add
   * @memberOf SetCache
   * @alias push
   * @param {*} value The value to cache.
   * @returns {Object} Returns the cache instance.
   */
function(t){return this.__data__.set(t,"__lodash_hash_undefined__"),this};
/**
   * Checks if `value` is in the array cache.
   *
   * @private
   * @name has
   * @memberOf SetCache
   * @param {*} value The value to search for.
   * @returns {number} Returns `true` if `value` is found, else `false`.
   */var yt=function(t){return this.__data__.has(t)};
/**
   *
   * Creates an array cache object to store unique values.
   *
   * @private
   * @constructor
   * @param {Array} [values] The values to cache.
   */function _t(t){var e=-1,n=null==t?0:t.length;for(this.__data__=new ht;++e<n;)this.add(t[e])}// Add methods to `SetCache`.
_t.prototype.add=_t.prototype.push=bt,_t.prototype.has=yt;var jt=_t;
/**
   * A specialized version of `_.some` for arrays without support for iteratee
   * shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} predicate The function invoked per iteration.
   * @returns {boolean} Returns `true` if any element passes the predicate check,
   *  else `false`.
   */var mt=function(t,e){for(var n=-1,r=null==t?0:t.length;++n<r;)if(e(t[n],n,t))return!0;return!1};
/**
   * Checks if a `cache` value for `key` exists.
   *
   * @private
   * @param {Object} cache The cache to query.
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */var kt=function(t,e){return t.has(e)};
/** Used to compose bitmasks for value comparisons. */var Ot=
/**
   * A specialized version of `baseIsEqualDeep` for arrays with support for
   * partial deep comparisons.
   *
   * @private
   * @param {Array} array The array to compare.
   * @param {Array} other The other array to compare.
   * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
   * @param {Function} customizer The function to customize comparisons.
   * @param {Function} equalFunc The function to determine equivalents of values.
   * @param {Object} stack Tracks traversed `array` and `other` objects.
   * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
   */
function(t,e,n,r,o,i){var a=1&n,c=t.length,u=e.length;if(c!=u&&!(a&&u>c))return!1;// Assume cyclic values are equal.
var s=i.get(t);if(s&&i.get(e))return s==e;var l=-1,f=!0,v=2&n?new jt:void 0;// Ignore non-index properties.
for(i.set(t,e),i.set(e,t);++l<c;){var h=t[l],p=e[l];if(r)var d=a?r(p,h,l,e,t,i):r(h,p,l,t,e,i);if(void 0!==d){if(d)continue;f=!1;break}// Recursively compare arrays (susceptible to call stack limits).
if(v){if(!mt(e,(function(t,e){if(!kt(v,e)&&(h===t||o(h,t,n,r,i)))return v.push(e)}))){f=!1;break}}else if(h!==p&&!o(h,p,n,r,i)){f=!1;break}}return i.delete(t),i.delete(e),f},wt=j.Uint8Array;
/** Built-in value references. */var xt=
/**
   * Converts `map` to its key-value pairs.
   *
   * @private
   * @param {Object} map The map to convert.
   * @returns {Array} Returns the key-value pairs.
   */
function(t){var e=-1,n=Array(t.size);return t.forEach((function(t,r){n[++e]=[r,t]})),n};
/**
   * Converts `set` to an array of its values.
   *
   * @private
   * @param {Object} set The set to convert.
   * @returns {Array} Returns the values.
   */var At=function(t){var e=-1,n=Array(t.size);return t.forEach((function(t){n[++e]=t})),n},Mt=m?m.prototype:void 0,St=Mt?Mt.valueOf:void 0;
/** Used to compose bitmasks for value comparisons. */var Pt=
/**
   * A specialized version of `baseIsEqualDeep` for comparing objects of
   * the same `toStringTag`.
   *
   * **Note:** This function only supports comparing values with tags of
   * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
   *
   * @private
   * @param {Object} object The object to compare.
   * @param {Object} other The other object to compare.
   * @param {string} tag The `toStringTag` of the objects to compare.
   * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
   * @param {Function} customizer The function to customize comparisons.
   * @param {Function} equalFunc The function to determine equivalents of values.
   * @param {Object} stack Tracks traversed `object` and `other` objects.
   * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
   */
function(t,e,n,o,i,a,c){switch(n){case"[object DataView]":if(t.byteLength!=e.byteLength||t.byteOffset!=e.byteOffset)return!1;t=t.buffer,e=e.buffer;case"[object ArrayBuffer]":return!(t.byteLength!=e.byteLength||!a(new wt(t),new wt(e)));case"[object Boolean]":case"[object Date]":case"[object Number]":
// Coerce booleans to `1` or `0` and dates to milliseconds.
// Invalid dates are coerced to `NaN`.
return r(+t,+e);case"[object Error]":return t.name==e.name&&t.message==e.message;case"[object RegExp]":case"[object String]":
// Coerce regexes to strings and treat strings, primitives and objects,
// as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
// for more details.
return t==e+"";case"[object Map]":var u=xt;case"[object Set]":var s=1&o;if(u||(u=At),t.size!=e.size&&!s)return!1;// Assume cyclic values are equal.
var l=c.get(t);if(l)return l==e;o|=2,// Recursively compare objects (susceptible to call stack limits).
c.set(t,e);var f=Ot(u(t),u(e),o,i,a,c);return c.delete(t),f;case"[object Symbol]":if(St)return St.call(t)==St.call(e)}return!1};
/**
   * Appends the elements of `values` to `array`.
   *
   * @private
   * @param {Array} array The array to modify.
   * @param {Array} values The values to append.
   * @returns {Array} Returns `array`.
   */var Et=function(t,e){for(var n=-1,r=e.length,o=t.length;++n<r;)t[o+n]=e[n];return t},Tt=Array.isArray;
/**
   * Checks if `value` is classified as an `Array` object.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an array, else `false`.
   * @example
   *
   * _.isArray([1, 2, 3]);
   * // => true
   *
   * _.isArray(document.body.children);
   * // => false
   *
   * _.isArray('abc');
   * // => false
   *
   * _.isArray(_.noop);
   * // => false
   */var Ct=
/**
   * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
   * `keysFunc` and `symbolsFunc` to get the enumerable property names and
   * symbols of `object`.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {Function} keysFunc The function to get the keys of `object`.
   * @param {Function} symbolsFunc The function to get the symbols of `object`.
   * @returns {Array} Returns the array of property names and symbols.
   */
function(t,e,n){var r=e(t);return Tt(t)?r:Et(r,n(t))};
/**
   * A specialized version of `_.filter` for arrays without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} predicate The function invoked per iteration.
   * @returns {Array} Returns the new filtered array.
   */var Ft=function(t,e){for(var n=-1,r=null==t?0:t.length,o=0,i=[];++n<r;){var a=t[n];e(a,n,t)&&(i[o++]=a)}return i};
/**
   * This method returns a new empty array.
   *
   * @static
   * @memberOf _
   * @since 4.13.0
   * @category Util
   * @returns {Array} Returns the new empty array.
   * @example
   *
   * var arrays = _.times(2, _.stubArray);
   *
   * console.log(arrays);
   * // => [[], []]
   *
   * console.log(arrays[0] === arrays[1]);
   * // => false
   */var zt=function(){return[]},Lt=Object.prototype.propertyIsEnumerable,It=Object.getOwnPropertySymbols,Rt=It?function(t){return null==t?[]:(t=Object(t),Ft(It(t),(function(e){return Lt.call(t,e)})))}:zt;
/** Used for built-in method references. */var $t=
/**
   * The base implementation of `_.times` without support for iteratee shorthands
   * or max array length checks.
   *
   * @private
   * @param {number} n The number of times to invoke `iteratee`.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns the array of results.
   */
function(t,e){for(var n=-1,r=Array(t);++n<t;)r[n]=e(n);return r};
/**
   * Checks if `value` is object-like. A value is object-like if it's not `null`
   * and has a `typeof` result of "object".
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
   * @example
   *
   * _.isObjectLike({});
   * // => true
   *
   * _.isObjectLike([1, 2, 3]);
   * // => true
   *
   * _.isObjectLike(_.noop);
   * // => false
   *
   * _.isObjectLike(null);
   * // => false
   */var Bt=function(t){return null!=t&&"object"==typeof t};
/** `Object#toString` result references. */var Wt=
/**
   * The base implementation of `_.isArguments`.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an `arguments` object,
   */
function(t){return Bt(t)&&"[object Arguments]"==E(t)},Ut=Object.prototype,Nt=Ut.hasOwnProperty,Dt=Ut.propertyIsEnumerable,Vt=Wt(function(){return arguments}())?Wt:function(t){return Bt(t)&&Nt.call(t,"callee")&&!Dt.call(t,"callee")};
/** Used for built-in method references. */var qt=
/**
   * This method returns `false`.
   *
   * @static
   * @memberOf _
   * @since 4.13.0
   * @category Util
   * @returns {boolean} Returns `false`.
   * @example
   *
   * _.times(2, _.stubFalse);
   * // => [false, false]
   */
function(){return!1},Gt=b((function(t,e){
/** Detect free variable `exports`. */
var n=e&&!e.nodeType&&e,r=n&&t&&!t.nodeType&&t,o=r&&r.exports===n?j.Buffer:void 0,i=(o?o.isBuffer:void 0)||qt;
/** Detect free variable `module`. */t.exports=i})),Ht=/^(?:0|[1-9]\d*)$/;var Jt=
/**
   * Checks if `value` is a valid array-like index.
   *
   * @private
   * @param {*} value The value to check.
   * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
   * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
   */
function(t,e){var n=typeof t;return!!(e=null==e?9007199254740991:e)&&("number"==n||"symbol"!=n&&Ht.test(t))&&t>-1&&t%1==0&&t<e};
/** Used as references for various `Number` constants. */var Kt=
/**
   * Checks if `value` is a valid array-like length.
   *
   * **Note:** This method is loosely based on
   * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
   * @example
   *
   * _.isLength(3);
   * // => true
   *
   * _.isLength(Number.MIN_VALUE);
   * // => false
   *
   * _.isLength(Infinity);
   * // => false
   *
   * _.isLength('3');
   * // => false
   */
function(t){return"number"==typeof t&&t>-1&&t%1==0&&t<=9007199254740991},Qt={};
/** `Object#toString` result references. */Qt["[object Float32Array]"]=Qt["[object Float64Array]"]=Qt["[object Int8Array]"]=Qt["[object Int16Array]"]=Qt["[object Int32Array]"]=Qt["[object Uint8Array]"]=Qt["[object Uint8ClampedArray]"]=Qt["[object Uint16Array]"]=Qt["[object Uint32Array]"]=!0,Qt["[object Arguments]"]=Qt["[object Array]"]=Qt["[object ArrayBuffer]"]=Qt["[object Boolean]"]=Qt["[object DataView]"]=Qt["[object Date]"]=Qt["[object Error]"]=Qt["[object Function]"]=Qt["[object Map]"]=Qt["[object Number]"]=Qt["[object Object]"]=Qt["[object RegExp]"]=Qt["[object Set]"]=Qt["[object String]"]=Qt["[object WeakMap]"]=!1;var Xt=
/**
   * The base implementation of `_.isTypedArray` without Node.js optimizations.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
   */
function(t){return Bt(t)&&Kt(t.length)&&!!Qt[E(t)]};
/**
   * The base implementation of `_.unary` without support for storing metadata.
   *
   * @private
   * @param {Function} func The function to cap arguments for.
   * @returns {Function} Returns the new capped function.
   */var Yt=function(t){return function(e){return t(e)}},Zt=b((function(t,e){
/** Detect free variable `exports`. */
var n=e&&!e.nodeType&&e,r=n&&t&&!t.nodeType&&t,o=r&&r.exports===n&&y.process,i=function(){try{
// Use `util.types` for Node.js 10+.
var t=r&&r.require&&r.require("util").types;return t||o&&o.binding&&o.binding("util");// Legacy `process.binding('util')` for Node.js < 10.
}catch(t){}}();
/** Detect free variable `module`. */t.exports=i})),te=Zt&&Zt.isTypedArray,ee=te?Yt(te):Xt,ne=Object.prototype.hasOwnProperty;var re=
/**
   * Creates an array of the enumerable property names of the array-like `value`.
   *
   * @private
   * @param {*} value The value to query.
   * @param {boolean} inherited Specify returning inherited property names.
   * @returns {Array} Returns the array of property names.
   */
function(t,e){var n=Tt(t),r=!n&&Vt(t),o=!n&&!r&&Gt(t),i=!n&&!r&&!o&&ee(t),a=n||r||o||i,c=a?$t(t.length,String):[],u=c.length;for(var s in t)!e&&!ne.call(t,s)||a&&(// Safari 9 has enumerable `arguments.length` in strict mode.
"length"==s||// Node.js 0.10 has enumerable non-index properties on buffers.
o&&("offset"==s||"parent"==s)||// PhantomJS 2 has enumerable non-index properties on typed arrays.
i&&("buffer"==s||"byteLength"==s||"byteOffset"==s)||// Skip index properties.
Jt(s,u))||c.push(s);return c},oe=Object.prototype;
/** Used for built-in method references. */var ie=
/**
   * Checks if `value` is likely a prototype object.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
   */
function(t){var e=t&&t.constructor;return t===("function"==typeof e&&e.prototype||oe)};
/**
   * Creates a unary function that invokes `func` with its argument transformed.
   *
   * @private
   * @param {Function} func The function to wrap.
   * @param {Function} transform The argument transform.
   * @returns {Function} Returns the new function.
   */var ae=function(t,e){return function(n){return t(e(n))}},ce=ae(Object.keys,Object),ue=Object.prototype.hasOwnProperty;
/* Built-in method references for those with the same name as other `lodash` methods. */var se=
/**
   * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names.
   */
function(t){if(!ie(t))return ce(t);var e=[];for(var n in Object(t))ue.call(t,n)&&"constructor"!=n&&e.push(n);return e};
/**
   * Checks if `value` is array-like. A value is considered array-like if it's
   * not a function and has a `value.length` that's an integer greater than or
   * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
   * @example
   *
   * _.isArrayLike([1, 2, 3]);
   * // => true
   *
   * _.isArrayLike(document.body.children);
   * // => true
   *
   * _.isArrayLike('abc');
   * // => true
   *
   * _.isArrayLike(_.noop);
   * // => false
   */var le=function(t){return null!=t&&Kt(t.length)&&!F(t)};
/**
   * Creates an array of the own enumerable property names of `object`.
   *
   * **Note:** Non-object values are coerced to objects. See the
   * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
   * for more details.
   *
   * @static
   * @since 0.1.0
   * @memberOf _
   * @category Object
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names.
   * @example
   *
   * function Foo() {
   *   this.a = 1;
   *   this.b = 2;
   * }
   *
   * Foo.prototype.c = 3;
   *
   * _.keys(new Foo);
   * // => ['a', 'b'] (iteration order is not guaranteed)
   *
   * _.keys('hi');
   * // => ['0', '1']
   */var fe=function(t){return le(t)?re(t):se(t)};
/**
   * Creates an array of own enumerable property names and symbols of `object`.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names and symbols.
   */var ve=function(t){return Ct(t,fe,Rt)},he=Object.prototype.hasOwnProperty;
/** Used to compose bitmasks for value comparisons. */var pe=
/**
   * A specialized version of `baseIsEqualDeep` for objects with support for
   * partial deep comparisons.
   *
   * @private
   * @param {Object} object The object to compare.
   * @param {Object} other The other object to compare.
   * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
   * @param {Function} customizer The function to customize comparisons.
   * @param {Function} equalFunc The function to determine equivalents of values.
   * @param {Object} stack Tracks traversed `object` and `other` objects.
   * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
   */
function(t,e,n,r,o,i){var a=1&n,c=ve(t),u=c.length;if(u!=ve(e).length&&!a)return!1;for(var s=u;s--;){var l=c[s];if(!(a?l in e:he.call(e,l)))return!1}// Assume cyclic values are equal.
var f=i.get(t);if(f&&i.get(e))return f==e;var v=!0;i.set(t,e),i.set(e,t);for(var h=a;++s<u;){var p=t[l=c[s]],d=e[l];if(r)var g=a?r(d,p,l,e,t,i):r(p,d,l,t,e,i);// Recursively compare objects (susceptible to call stack limits).
if(!(void 0===g?p===d||o(p,d,n,r,i):g)){v=!1;break}h||(h="constructor"==l)}if(v&&!h){var b=t.constructor,y=e.constructor;// Non `Object` object instances with different constructors are not equal.
b!=y&&"constructor"in t&&"constructor"in e&&!("function"==typeof b&&b instanceof b&&"function"==typeof y&&y instanceof y)&&(v=!1)}return i.delete(t),i.delete(e),v},de=H(j,"DataView"),ge=H(j,"Promise"),be=H(j,"Set"),ye=H(j,"WeakMap"),_e=$(de),je=$(J),me=$(ge),ke=$(be),Oe=$(ye),we=E;
/* Built-in method references that are verified to be native. */ // Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.
(de&&"[object DataView]"!=we(new de(new ArrayBuffer(1)))||J&&"[object Map]"!=we(new J)||ge&&"[object Promise]"!=we(ge.resolve())||be&&"[object Set]"!=we(new be)||ye&&"[object WeakMap]"!=we(new ye))&&(we=function(t){var e=E(t),n="[object Object]"==e?t.constructor:void 0,r=n?$(n):"";if(r)switch(r){case _e:return"[object DataView]";case je:return"[object Map]";case me:return"[object Promise]";case ke:return"[object Set]";case Oe:return"[object WeakMap]"}return e});var xe=we,Ae=Object.prototype.hasOwnProperty;
/** Used to compose bitmasks for value comparisons. */var Me=
/**
   * A specialized version of `baseIsEqual` for arrays and objects which performs
   * deep comparisons and tracks traversed objects enabling objects with circular
   * references to be compared.
   *
   * @private
   * @param {Object} object The object to compare.
   * @param {Object} other The other object to compare.
   * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
   * @param {Function} customizer The function to customize comparisons.
   * @param {Function} equalFunc The function to determine equivalents of values.
   * @param {Object} [stack] Tracks traversed `object` and `other` objects.
   * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
   */
function(t,e,n,r,o,i){var a=Tt(t),c=Tt(e),u=a?"[object Array]":xe(t),s=c?"[object Array]":xe(e),l="[object Object]"==(u="[object Arguments]"==u?"[object Object]":u),f="[object Object]"==(s="[object Arguments]"==s?"[object Object]":s),v=u==s;if(v&&Gt(t)){if(!Gt(e))return!1;a=!0,l=!1}if(v&&!l)return i||(i=new gt),a||ee(t)?Ot(t,e,n,r,o,i):Pt(t,e,u,n,r,o,i);if(!(1&n)){var h=l&&Ae.call(t,"__wrapped__"),p=f&&Ae.call(e,"__wrapped__");if(h||p){var d=h?t.value():t,g=p?e.value():e;return i||(i=new gt),o(d,g,n,r,i)}}return!!v&&(i||(i=new gt),pe(t,e,n,r,o,i))};
/**
   * The base implementation of `_.isEqual` which supports partial comparisons
   * and tracks traversed objects.
   *
   * @private
   * @param {*} value The value to compare.
   * @param {*} other The other value to compare.
   * @param {boolean} bitmask The bitmask flags.
   *  1 - Unordered comparison
   *  2 - Partial comparison
   * @param {Function} [customizer] The function to customize comparisons.
   * @param {Object} [stack] Tracks traversed `value` and `other` objects.
   * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
   */var Se=function t(e,n,r,o,i){return e===n||(null==e||null==n||!Bt(e)&&!Bt(n)?e!=e&&n!=n:Me(e,n,r,o,t,i))};
/** Used to compose bitmasks for value comparisons. */var Pe=
/**
   * The base implementation of `_.isMatch` without support for iteratee shorthands.
   *
   * @private
   * @param {Object} object The object to inspect.
   * @param {Object} source The object of property values to match.
   * @param {Array} matchData The property names, values, and compare flags to match.
   * @param {Function} [customizer] The function to customize comparisons.
   * @returns {boolean} Returns `true` if `object` is a match, else `false`.
   */
function(t,e,n,r){var o=n.length,i=o,a=!r;if(null==t)return!i;for(t=Object(t);o--;){var c=n[o];if(a&&c[2]?c[1]!==t[c[0]]:!(c[0]in t))return!1}for(;++o<i;){var u=(c=n[o])[0],s=t[u],l=c[1];if(a&&c[2]){if(void 0===s&&!(u in t))return!1}else{var f=new gt;if(r)var v=r(s,l,u,t,e,f);if(!(void 0===v?Se(l,s,3,r,f):v))return!1}}return!0};
/**
   * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` if suitable for strict
   *  equality comparisons, else `false`.
   */var Ee=function(t){return t==t&&!T(t)};
/**
   * Gets the property names, values, and compare flags of `object`.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Array} Returns the match data of `object`.
   */var Te=function(t){for(var e=fe(t),n=e.length;n--;){var r=e[n],o=t[r];e[n]=[r,o,Ee(o)]}return e};
/**
   * A specialized version of `matchesProperty` for source values suitable
   * for strict equality comparisons, i.e. `===`.
   *
   * @private
   * @param {string} key The key of the property to get.
   * @param {*} srcValue The value to match.
   * @returns {Function} Returns the new spec function.
   */var Ce=function(t,e){return function(n){return null!=n&&(n[t]===e&&(void 0!==e||t in Object(n)))}};
/**
   * The base implementation of `_.matches` which doesn't clone `source`.
   *
   * @private
   * @param {Object} source The object of property values to match.
   * @returns {Function} Returns the new spec function.
   */var Fe=function(t){var e=Te(t);return 1==e.length&&e[0][2]?Ce(e[0][0],e[0][1]):function(n){return n===t||Pe(n,t,e)}};
/** `Object#toString` result references. */var ze=
/**
   * Checks if `value` is classified as a `Symbol` primitive or object.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
   * @example
   *
   * _.isSymbol(Symbol.iterator);
   * // => true
   *
   * _.isSymbol('abc');
   * // => false
   */
function(t){return"symbol"==typeof t||Bt(t)&&"[object Symbol]"==E(t)},Le=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,Ie=/^\w*$/;
/** Used to match property names within property paths. */var Re=
/**
   * Checks if `value` is a property name and not a property path.
   *
   * @private
   * @param {*} value The value to check.
   * @param {Object} [object] The object to query keys on.
   * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
   */
function(t,e){if(Tt(t))return!1;var n=typeof t;return!("number"!=n&&"symbol"!=n&&"boolean"!=n&&null!=t&&!ze(t))||(Ie.test(t)||!Le.test(t)||null!=e&&t in Object(e))};
/** Error message constants. */
/**
   * Creates a function that memoizes the result of `func`. If `resolver` is
   * provided, it determines the cache key for storing the result based on the
   * arguments provided to the memoized function. By default, the first argument
   * provided to the memoized function is used as the map cache key. The `func`
   * is invoked with the `this` binding of the memoized function.
   *
   * **Note:** The cache is exposed as the `cache` property on the memoized
   * function. Its creation may be customized by replacing the `_.memoize.Cache`
   * constructor with one whose instances implement the
   * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
   * method interface of `clear`, `delete`, `get`, `has`, and `set`.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Function
   * @param {Function} func The function to have its output memoized.
   * @param {Function} [resolver] The function to resolve the cache key.
   * @returns {Function} Returns the new memoized function.
   * @example
   *
   * var object = { 'a': 1, 'b': 2 };
   * var other = { 'c': 3, 'd': 4 };
   *
   * var values = _.memoize(_.values);
   * values(object);
   * // => [1, 2]
   *
   * values(other);
   * // => [3, 4]
   *
   * object.a = 2;
   * values(object);
   * // => [1, 2]
   *
   * // Modify the result cache.
   * values.cache.set(object, ['a', 'b']);
   * values(object);
   * // => ['a', 'b']
   *
   * // Replace `_.memoize.Cache`.
   * _.memoize.Cache = WeakMap;
   */
function $e(t,e){if("function"!=typeof t||null!=e&&"function"!=typeof e)throw new TypeError("Expected a function");var n=function(){var r=arguments,o=e?e.apply(this,r):r[0],i=n.cache;if(i.has(o))return i.get(o);var a=t.apply(this,r);return n.cache=i.set(o,a)||i,a};return n.cache=new($e.Cache||ht),n}// Expose `MapCache`.
$e.Cache=ht;var Be=$e;
/** Used as the maximum memoize cache size. */var We=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,Ue=/\\(\\)?/g,Ne=
/**
   * A specialized version of `_.memoize` which clears the memoized function's
   * cache when it exceeds `MAX_MEMOIZE_SIZE`.
   *
   * @private
   * @param {Function} func The function to have its output memoized.
   * @returns {Function} Returns the new memoized function.
   */
function(t){var e=Be(t,(function(t){return 500===n.size&&n.clear(),t})),n=e.cache;return e}((function(t){var e=[];return 46
/* . */===t.charCodeAt(0)&&e.push(""),t.replace(We,(function(t,n,r,o){e.push(r?o.replace(Ue,"$1"):n||t)})),e})),De=m?m.prototype:void 0,Ve=De?De.toString:void 0;
/** Used to match property names within property paths. */var qe=
/**
   * The base implementation of `_.toString` which doesn't convert nullish
   * values to empty strings.
   *
   * @private
   * @param {*} value The value to process.
   * @returns {string} Returns the string.
   */
function t(n){
// Exit early for strings to avoid a performance hit in some environments.
if("string"==typeof n)return n;if(Tt(n))
// Recursively convert values (susceptible to call stack limits).
return e(n,t)+"";if(ze(n))return Ve?Ve.call(n):"";var r=n+"";return"0"==r&&1/n==-1/0?"-0":r};
/**
   * Converts `value` to a string. An empty string is returned for `null`
   * and `undefined` values. The sign of `-0` is preserved.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to convert.
   * @returns {string} Returns the converted string.
   * @example
   *
   * _.toString(null);
   * // => ''
   *
   * _.toString(-0);
   * // => '-0'
   *
   * _.toString([1, 2, 3]);
   * // => '1,2,3'
   */var Ge=function(t){return null==t?"":qe(t)};
/**
   * Casts `value` to a path array if it's not one.
   *
   * @private
   * @param {*} value The value to inspect.
   * @param {Object} [object] The object to query keys on.
   * @returns {Array} Returns the cast property path array.
   */var He=function(t,e){return Tt(t)?t:Re(t,e)?[t]:Ne(Ge(t))};
/** Used as references for various `Number` constants. */var Je=
/**
   * Converts `value` to a string key if it's not a string or symbol.
   *
   * @private
   * @param {*} value The value to inspect.
   * @returns {string|symbol} Returns the key.
   */
function(t){if("string"==typeof t||ze(t))return t;var e=t+"";return"0"==e&&1/t==-1/0?"-0":e};
/**
   * The base implementation of `_.get` without support for default values.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {Array|string} path The path of the property to get.
   * @returns {*} Returns the resolved value.
   */var Ke=function(t,e){for(var n=0,r=(e=He(e,t)).length;null!=t&&n<r;)t=t[Je(e[n++])];return n&&n==r?t:void 0};
/**
   * Gets the value at `path` of `object`. If the resolved value is
   * `undefined`, the `defaultValue` is returned in its place.
   *
   * @static
   * @memberOf _
   * @since 3.7.0
   * @category Object
   * @param {Object} object The object to query.
   * @param {Array|string} path The path of the property to get.
   * @param {*} [defaultValue] The value returned for `undefined` resolved values.
   * @returns {*} Returns the resolved value.
   * @example
   *
   * var object = { 'a': [{ 'b': { 'c': 3 } }] };
   *
   * _.get(object, 'a[0].b.c');
   * // => 3
   *
   * _.get(object, ['a', '0', 'b', 'c']);
   * // => 3
   *
   * _.get(object, 'a.b.c', 'default');
   * // => 'default'
   */var Qe=function(t,e,n){var r=null==t?void 0:Ke(t,e);return void 0===r?n:r};
/**
   * The base implementation of `_.hasIn` without support for deep paths.
   *
   * @private
   * @param {Object} [object] The object to query.
   * @param {Array|string} key The key to check.
   * @returns {boolean} Returns `true` if `key` exists, else `false`.
   */var Xe=function(t,e){return null!=t&&e in Object(t)};
/**
   * Checks if `path` exists on `object`.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {Array|string} path The path to check.
   * @param {Function} hasFunc The function to check properties.
   * @returns {boolean} Returns `true` if `path` exists, else `false`.
   */var Ye=function(t,e,n){for(var r=-1,o=(e=He(e,t)).length,i=!1;++r<o;){var a=Je(e[r]);if(!(i=null!=t&&n(t,a)))break;t=t[a]}return i||++r!=o?i:!!(o=null==t?0:t.length)&&Kt(o)&&Jt(a,o)&&(Tt(t)||Vt(t))};
/**
   * Checks if `path` is a direct or inherited property of `object`.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Object
   * @param {Object} object The object to query.
   * @param {Array|string} path The path to check.
   * @returns {boolean} Returns `true` if `path` exists, else `false`.
   * @example
   *
   * var object = _.create({ 'a': _.create({ 'b': 2 }) });
   *
   * _.hasIn(object, 'a');
   * // => true
   *
   * _.hasIn(object, 'a.b');
   * // => true
   *
   * _.hasIn(object, ['a', 'b']);
   * // => true
   *
   * _.hasIn(object, 'b');
   * // => false
   */var Ze=function(t,e){return null!=t&&Ye(t,e,Xe)};
/** Used to compose bitmasks for value comparisons. */var tn=
/**
   * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
   *
   * @private
   * @param {string} path The path of the property to get.
   * @param {*} srcValue The value to match.
   * @returns {Function} Returns the new spec function.
   */
function(t,e){return Re(t)&&Ee(e)?Ce(Je(t),e):function(n){var r=Qe(n,t);return void 0===r&&r===e?Ze(n,t):Se(e,r,3)}};
/**
   * This method returns the first argument it receives.
   *
   * @static
   * @since 0.1.0
   * @memberOf _
   * @category Util
   * @param {*} value Any value.
   * @returns {*} Returns `value`.
   * @example
   *
   * var object = { 'a': 1 };
   *
   * console.log(_.identity(object) === object);
   * // => true
   */var en=function(t){return t};
/**
   * The base implementation of `_.property` without support for deep paths.
   *
   * @private
   * @param {string} key The key of the property to get.
   * @returns {Function} Returns the new accessor function.
   */var nn=function(t){return function(e){return null==e?void 0:e[t]}};
/**
   * A specialized version of `baseProperty` which supports deep paths.
   *
   * @private
   * @param {Array|string} path The path of the property to get.
   * @returns {Function} Returns the new accessor function.
   */var rn=function(t){return function(e){return Ke(e,t)}};
/**
   * Creates a function that returns the value at `path` of a given object.
   *
   * @static
   * @memberOf _
   * @since 2.4.0
   * @category Util
   * @param {Array|string} path The path of the property to get.
   * @returns {Function} Returns the new accessor function.
   * @example
   *
   * var objects = [
   *   { 'a': { 'b': 2 } },
   *   { 'a': { 'b': 1 } }
   * ];
   *
   * _.map(objects, _.property('a.b'));
   * // => [2, 1]
   *
   * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');
   * // => [1, 2]
   */var on=function(t){return Re(t)?nn(Je(t)):rn(t)};
/**
   * The base implementation of `_.iteratee`.
   *
   * @private
   * @param {*} [value=_.identity] The value to convert to an iteratee.
   * @returns {Function} Returns the iteratee.
   */var an=function(t){
// Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
// See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
return"function"==typeof t?t:null==t?en:"object"==typeof t?Tt(t)?tn(t[0],t[1]):Fe(t):on(t)};
/**
   * Creates a base function for methods like `_.forIn` and `_.forOwn`.
   *
   * @private
   * @param {boolean} [fromRight] Specify iterating from right to left.
   * @returns {Function} Returns the new base function.
   */var cn=function(t){return function(e,n,r){for(var o=-1,i=Object(e),a=r(e),c=a.length;c--;){var u=a[t?c:++o];if(!1===n(i[u],u,i))break}return e}}();
/**
   * The base implementation of `baseForOwn` which iterates over `object`
   * properties returned by `keysFunc` and invokes `iteratee` for each property.
   * Iteratee functions may exit iteration early by explicitly returning `false`.
   *
   * @private
   * @param {Object} object The object to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @param {Function} keysFunc The function to get the keys of `object`.
   * @returns {Object} Returns `object`.
   */var un=
/**
   * Creates a `baseEach` or `baseEachRight` function.
   *
   * @private
   * @param {Function} eachFunc The function to iterate over a collection.
   * @param {boolean} [fromRight] Specify iterating from right to left.
   * @returns {Function} Returns the new base function.
   */
function(t,e){return function(n,r){if(null==n)return n;if(!le(n))return t(n,r);for(var o=n.length,i=e?o:-1,a=Object(n);(e?i--:++i<o)&&!1!==r(a[i],i,a););return n}}((
/**
   * The base implementation of `_.forOwn` without support for iteratee shorthands.
   *
   * @private
   * @param {Object} object The object to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Object} Returns `object`.
   */
function(t,e){return t&&cn(t,e,fe)}));
/**
   * The base implementation of `_.forEach` without support for iteratee shorthands.
   *
   * @private
   * @param {Array|Object} collection The collection to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array|Object} Returns `collection`.
   */var sn=
/**
   * The base implementation of `_.map` without support for iteratee shorthands.
   *
   * @private
   * @param {Array|Object} collection The collection to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns the new mapped array.
   */
function(t,e){var n=-1,r=le(t)?Array(t.length):[];return un(t,(function(t,o,i){r[++n]=e(t,o,i)})),r};
/**
   * Creates an array of values by running each element in `collection` thru
   * `iteratee`. The iteratee is invoked with three arguments:
   * (value, index|key, collection).
   *
   * Many lodash methods are guarded to work as iteratees for methods like
   * `_.every`, `_.filter`, `_.map`, `_.mapValues`, `_.reject`, and `_.some`.
   *
   * The guarded methods are:
   * `ary`, `chunk`, `curry`, `curryRight`, `drop`, `dropRight`, `every`,
   * `fill`, `invert`, `parseInt`, `random`, `range`, `rangeRight`, `repeat`,
   * `sampleSize`, `slice`, `some`, `sortBy`, `split`, `take`, `takeRight`,
   * `template`, `trim`, `trimEnd`, `trimStart`, and `words`
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Collection
   * @param {Array|Object} collection The collection to iterate over.
   * @param {Function} [iteratee=_.identity] The function invoked per iteration.
   * @returns {Array} Returns the new mapped array.
   * @example
   *
   * function square(n) {
   *   return n * n;
   * }
   *
   * _.map([4, 8], square);
   * // => [16, 64]
   *
   * _.map({ 'a': 4, 'b': 8 }, square);
   * // => [16, 64] (iteration order is not guaranteed)
   *
   * var users = [
   *   { 'user': 'barney' },
   *   { 'user': 'fred' }
   * ];
   *
   * // The `_.property` iteratee shorthand.
   * _.map(users, 'user');
   * // => ['barney', 'fred']
   */var ln=function(t,n){return(Tt(t)?e:sn)(t,an(n))};
/**
   * A specialized version of `_.forEach` for arrays without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns `array`.
   */var fn=function(t,e){for(var n=-1,r=null==t?0:t.length;++n<r&&!1!==e(t[n],n,t););return t},vn=function(){try{var t=H(Object,"defineProperty");return t({},"",{}),t}catch(t){}}();var hn=
/**
   * The base implementation of `assignValue` and `assignMergeValue` without
   * value checks.
   *
   * @private
   * @param {Object} object The object to modify.
   * @param {string} key The key of the property to assign.
   * @param {*} value The value to assign.
   */
function(t,e,n){"__proto__"==e&&vn?vn(t,e,{configurable:!0,enumerable:!0,value:n,writable:!0}):t[e]=n},pn=Object.prototype.hasOwnProperty;
/** Used for built-in method references. */var dn=
/**
   * Assigns `value` to `key` of `object` if the existing value is not equivalent
   * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
   * for equality comparisons.
   *
   * @private
   * @param {Object} object The object to modify.
   * @param {string} key The key of the property to assign.
   * @param {*} value The value to assign.
   */
function(t,e,n){var o=t[e];pn.call(t,e)&&r(o,n)&&(void 0!==n||e in t)||hn(t,e,n)};
/**
   * Copies properties of `source` to `object`.
   *
   * @private
   * @param {Object} source The object to copy properties from.
   * @param {Array} props The property identifiers to copy.
   * @param {Object} [object={}] The object to copy properties to.
   * @param {Function} [customizer] The function to customize copied values.
   * @returns {Object} Returns `object`.
   */var gn=function(t,e,n,r){var o=!n;n||(n={});for(var i=-1,a=e.length;++i<a;){var c=e[i],u=r?r(n[c],t[c],c,n,t):void 0;void 0===u&&(u=t[c]),o?hn(n,c,u):dn(n,c,u)}return n};
/**
   * The base implementation of `_.assign` without support for multiple sources
   * or `customizer` functions.
   *
   * @private
   * @param {Object} object The destination object.
   * @param {Object} source The source object.
   * @returns {Object} Returns `object`.
   */var bn=function(t,e){return t&&gn(e,fe(e),t)};
/**
   * This function is like
   * [`Object.keys`](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
   * except that it includes inherited enumerable properties.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names.
   */var yn=function(t){var e=[];if(null!=t)for(var n in Object(t))e.push(n);return e},_n=Object.prototype.hasOwnProperty;
/** Used for built-in method references. */var jn=
/**
   * The base implementation of `_.keysIn` which doesn't treat sparse arrays as dense.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names.
   */
function(t){if(!T(t))return yn(t);var e=ie(t),n=[];for(var r in t)("constructor"!=r||!e&&_n.call(t,r))&&n.push(r);return n};
/**
   * Creates an array of the own and inherited enumerable property names of `object`.
   *
   * **Note:** Non-object values are coerced to objects.
   *
   * @static
   * @memberOf _
   * @since 3.0.0
   * @category Object
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names.
   * @example
   *
   * function Foo() {
   *   this.a = 1;
   *   this.b = 2;
   * }
   *
   * Foo.prototype.c = 3;
   *
   * _.keysIn(new Foo);
   * // => ['a', 'b', 'c'] (iteration order is not guaranteed)
   */var mn=function(t){return le(t)?re(t,!0):jn(t)};
/**
   * The base implementation of `_.assignIn` without support for multiple sources
   * or `customizer` functions.
   *
   * @private
   * @param {Object} object The destination object.
   * @param {Object} source The source object.
   * @returns {Object} Returns `object`.
   */var kn=function(t,e){return t&&gn(e,mn(e),t)},On=b((function(t,e){
/** Detect free variable `exports`. */
var n=e&&!e.nodeType&&e,r=n&&t&&!t.nodeType&&t,o=r&&r.exports===n?j.Buffer:void 0,i=o?o.allocUnsafe:void 0;
/** Detect free variable `module`. */t.exports=
/**
   * Creates a clone of  `buffer`.
   *
   * @private
   * @param {Buffer} buffer The buffer to clone.
   * @param {boolean} [isDeep] Specify a deep clone.
   * @returns {Buffer} Returns the cloned buffer.
   */
function(t,e){if(e)return t.slice();var n=t.length,r=i?i(n):new t.constructor(n);return t.copy(r),r}}));var wn=
/**
   * Copies the values of `source` to `array`.
   *
   * @private
   * @param {Array} source The array to copy values from.
   * @param {Array} [array=[]] The array to copy values to.
   * @returns {Array} Returns `array`.
   */
function(t,e){var n=-1,r=t.length;for(e||(e=Array(r));++n<r;)e[n]=t[n];return e};
/**
   * Copies own symbols of `source` to `object`.
   *
   * @private
   * @param {Object} source The object to copy symbols from.
   * @param {Object} [object={}] The object to copy symbols to.
   * @returns {Object} Returns `object`.
   */var xn=function(t,e){return gn(t,Rt(t),e)},An=ae(Object.getPrototypeOf,Object),Mn=Object.getOwnPropertySymbols?function(t){for(var e=[];t;)Et(e,Rt(t)),t=An(t);return e}:zt;
/** Built-in value references. */var Sn=
/**
   * Copies own and inherited symbols of `source` to `object`.
   *
   * @private
   * @param {Object} source The object to copy symbols from.
   * @param {Object} [object={}] The object to copy symbols to.
   * @returns {Object} Returns `object`.
   */
function(t,e){return gn(t,Mn(t),e)};
/**
   * Creates an array of own and inherited enumerable property names and
   * symbols of `object`.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names and symbols.
   */var Pn=function(t){return Ct(t,mn,Mn)},En=Object.prototype.hasOwnProperty;
/** Used for built-in method references. */var Tn=
/**
   * Initializes an array clone.
   *
   * @private
   * @param {Array} array The array to clone.
   * @returns {Array} Returns the initialized clone.
   */
function(t){var e=t.length,n=new t.constructor(e);// Add properties assigned by `RegExp#exec`.
return e&&"string"==typeof t[0]&&En.call(t,"index")&&(n.index=t.index,n.input=t.input),n};
/**
   * Creates a clone of `arrayBuffer`.
   *
   * @private
   * @param {ArrayBuffer} arrayBuffer The array buffer to clone.
   * @returns {ArrayBuffer} Returns the cloned array buffer.
   */var Cn=function(t){var e=new t.constructor(t.byteLength);return new wt(e).set(new wt(t)),e};
/**
   * Creates a clone of `dataView`.
   *
   * @private
   * @param {Object} dataView The data view to clone.
   * @param {boolean} [isDeep] Specify a deep clone.
   * @returns {Object} Returns the cloned data view.
   */var Fn=function(t,e){var n=e?Cn(t.buffer):t.buffer;return new t.constructor(n,t.byteOffset,t.byteLength)},zn=/\w*$/;
/** Used to match `RegExp` flags from their coerced string values. */var Ln=
/**
   * Creates a clone of `regexp`.
   *
   * @private
   * @param {Object} regexp The regexp to clone.
   * @returns {Object} Returns the cloned regexp.
   */
function(t){var e=new t.constructor(t.source,zn.exec(t));return e.lastIndex=t.lastIndex,e},In=m?m.prototype:void 0,Rn=In?In.valueOf:void 0;
/** Used to convert symbols to primitives and strings. */var $n=
/**
   * Creates a clone of the `symbol` object.
   *
   * @private
   * @param {Object} symbol The symbol object to clone.
   * @returns {Object} Returns the cloned symbol object.
   */
function(t){return Rn?Object(Rn.call(t)):{}};
/**
   * Creates a clone of `typedArray`.
   *
   * @private
   * @param {Object} typedArray The typed array to clone.
   * @param {boolean} [isDeep] Specify a deep clone.
   * @returns {Object} Returns the cloned typed array.
   */var Bn=function(t,e){var n=e?Cn(t.buffer):t.buffer;return new t.constructor(n,t.byteOffset,t.length)};
/** `Object#toString` result references. */var Wn=
/**
   * Initializes an object clone based on its `toStringTag`.
   *
   * **Note:** This function only supports cloning values with tags of
   * `Boolean`, `Date`, `Error`, `Map`, `Number`, `RegExp`, `Set`, or `String`.
   *
   * @private
   * @param {Object} object The object to clone.
   * @param {string} tag The `toStringTag` of the object to clone.
   * @param {boolean} [isDeep] Specify a deep clone.
   * @returns {Object} Returns the initialized clone.
   */
function(t,e,n){var r=t.constructor;switch(e){case"[object ArrayBuffer]":return Cn(t);case"[object Boolean]":case"[object Date]":return new r(+t);case"[object DataView]":return Fn(t,n);case"[object Float32Array]":case"[object Float64Array]":case"[object Int8Array]":case"[object Int16Array]":case"[object Int32Array]":case"[object Uint8Array]":case"[object Uint8ClampedArray]":case"[object Uint16Array]":case"[object Uint32Array]":return Bn(t,n);case"[object Map]":return new r;case"[object Number]":case"[object String]":return new r(t);case"[object RegExp]":return Ln(t);case"[object Set]":return new r;case"[object Symbol]":return $n(t)}},Un=Object.create,Nn=function(){function t(){}return function(e){if(!T(e))return{};if(Un)return Un(e);t.prototype=e;var n=new t;return t.prototype=void 0,n}}();
/** Built-in value references. */var Dn=
/**
   * Initializes an object clone.
   *
   * @private
   * @param {Object} object The object to clone.
   * @returns {Object} Returns the initialized clone.
   */
function(t){return"function"!=typeof t.constructor||ie(t)?{}:Nn(An(t))};
/** `Object#toString` result references. */var Vn=
/**
   * The base implementation of `_.isMap` without Node.js optimizations.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a map, else `false`.
   */
function(t){return Bt(t)&&"[object Map]"==xe(t)},qn=Zt&&Zt.isMap,Gn=qn?Yt(qn):Vn;
/* Node.js helper references. */var Hn=
/**
   * The base implementation of `_.isSet` without Node.js optimizations.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a set, else `false`.
   */
function(t){return Bt(t)&&"[object Set]"==xe(t)},Jn=Zt&&Zt.isSet,Kn=Jn?Yt(Jn):Hn,Qn={};
/* Node.js helper references. */Qn["[object Arguments]"]=Qn["[object Array]"]=Qn["[object ArrayBuffer]"]=Qn["[object DataView]"]=Qn["[object Boolean]"]=Qn["[object Date]"]=Qn["[object Float32Array]"]=Qn["[object Float64Array]"]=Qn["[object Int8Array]"]=Qn["[object Int16Array]"]=Qn["[object Int32Array]"]=Qn["[object Map]"]=Qn["[object Number]"]=Qn["[object Object]"]=Qn["[object RegExp]"]=Qn["[object Set]"]=Qn["[object String]"]=Qn["[object Symbol]"]=Qn["[object Uint8Array]"]=Qn["[object Uint8ClampedArray]"]=Qn["[object Uint16Array]"]=Qn["[object Uint32Array]"]=!0,Qn["[object Error]"]=Qn["[object Function]"]=Qn["[object WeakMap]"]=!1;var Xn=
/**
   * The base implementation of `_.clone` and `_.cloneDeep` which tracks
   * traversed objects.
   *
   * @private
   * @param {*} value The value to clone.
   * @param {boolean} bitmask The bitmask flags.
   *  1 - Deep clone
   *  2 - Flatten inherited properties
   *  4 - Clone symbols
   * @param {Function} [customizer] The function to customize cloning.
   * @param {string} [key] The key of `value`.
   * @param {Object} [object] The parent object of `value`.
   * @param {Object} [stack] Tracks traversed objects and their clone counterparts.
   * @returns {*} Returns the cloned value.
   */
function t(e,n,r,o,i,a){var c,u=1&n,s=2&n,l=4&n;if(r&&(c=i?r(e,o,i,a):r(e)),void 0!==c)return c;if(!T(e))return e;var f=Tt(e);if(f){if(c=Tn(e),!u)return wn(e,c)}else{var v=xe(e),h="[object Function]"==v||"[object GeneratorFunction]"==v;if(Gt(e))return On(e,u);if("[object Object]"==v||"[object Arguments]"==v||h&&!i){if(c=s||h?{}:Dn(e),!u)return s?Sn(e,kn(c,e)):xn(e,bn(c,e))}else{if(!Qn[v])return i?e:{};c=Wn(e,v,u)}}// Check for circular references and return its corresponding clone.
a||(a=new gt);var p=a.get(e);if(p)return p;a.set(e,c),Kn(e)?e.forEach((function(o){c.add(t(o,n,r,o,e,a))})):Gn(e)&&e.forEach((function(o,i){c.set(i,t(o,n,r,i,e,a))}));var d=l?s?Pn:ve:s?keysIn:fe,g=f?void 0:d(e);return fn(g||e,(function(o,i){g&&(o=e[i=o]),// Recursively populate clone (susceptible to call stack limits).
dn(c,i,t(o,n,r,i,e,a))})),c};
/** Used to compose bitmasks for cloning. */var Yn=
/**
   * This method is like `_.clone` except that it recursively clones `value`.
   *
   * @static
   * @memberOf _
   * @since 1.0.0
   * @category Lang
   * @param {*} value The value to recursively clone.
   * @returns {*} Returns the deep cloned value.
   * @see _.clone
   * @example
   *
   * var objects = [{ 'a': 1 }, { 'b': 2 }];
   *
   * var deep = _.cloneDeep(objects);
   * console.log(deep[0] === objects[0]);
   * // => false
   */
function(t){return Xn(t,5)};
/**
   * Casts `value` to `identity` if it's not a function.
   *
   * @private
   * @param {*} value The value to inspect.
   * @returns {Function} Returns cast function.
   */var Zn=function(t){return"function"==typeof t?t:en};
/**
   * Iterates over elements of `collection` and invokes `iteratee` for each element.
   * The iteratee is invoked with three arguments: (value, index|key, collection).
   * Iteratee functions may exit iteration early by explicitly returning `false`.
   *
   * **Note:** As with other "Collections" methods, objects with a "length"
   * property are iterated like arrays. To avoid this behavior use `_.forIn`
   * or `_.forOwn` for object iteration.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @alias each
   * @category Collection
   * @param {Array|Object} collection The collection to iterate over.
   * @param {Function} [iteratee=_.identity] The function invoked per iteration.
   * @returns {Array|Object} Returns `collection`.
   * @see _.forEachRight
   * @example
   *
   * _.forEach([1, 2], function(value) {
   *   console.log(value);
   * });
   * // => Logs `1` then `2`.
   *
   * _.forEach({ 'a': 1, 'b': 2 }, function(value, key) {
   *   console.log(key);
   * });
   * // => Logs 'a' then 'b' (iteration order is not guaranteed).
   */var tr=function(t,e){return(Tt(t)?fn:un)(t,Zn(e))};var er=
/**
   * A faster alternative to `Function#apply`, this function invokes `func`
   * with the `this` binding of `thisArg` and the arguments of `args`.
   *
   * @private
   * @param {Function} func The function to invoke.
   * @param {*} thisArg The `this` binding of `func`.
   * @param {Array} args The arguments to invoke `func` with.
   * @returns {*} Returns the result of `func`.
   */
function(t,e,n){switch(n.length){case 0:return t.call(e);case 1:return t.call(e,n[0]);case 2:return t.call(e,n[0],n[1]);case 3:return t.call(e,n[0],n[1],n[2])}return t.apply(e,n)},nr=Math.max;
/* Built-in method references for those with the same name as other `lodash` methods. */var rr=
/**
   * A specialized version of `baseRest` which transforms the rest array.
   *
   * @private
   * @param {Function} func The function to apply a rest parameter to.
   * @param {number} [start=func.length-1] The start position of the rest parameter.
   * @param {Function} transform The rest array transform.
   * @returns {Function} Returns the new function.
   */
function(t,e,n){return e=nr(void 0===e?t.length-1:e,0),function(){for(var r=arguments,o=-1,i=nr(r.length-e,0),a=Array(i);++o<i;)a[o]=r[e+o];o=-1;for(var c=Array(e+1);++o<e;)c[o]=r[o];return c[e]=n(a),er(t,this,c)}};
/**
   * Creates a function that returns `value`.
   *
   * @static
   * @memberOf _
   * @since 2.4.0
   * @category Util
   * @param {*} value The value to return from the new function.
   * @returns {Function} Returns the new constant function.
   * @example
   *
   * var objects = _.times(2, _.constant({ 'a': 1 }));
   *
   * console.log(objects);
   * // => [{ 'a': 1 }, { 'a': 1 }]
   *
   * console.log(objects[0] === objects[1]);
   * // => true
   */var or=function(t){return function(){return t}},ir=vn?function(t,e){return vn(t,"toString",{configurable:!0,enumerable:!1,value:or(e),writable:!0})}:en,ar=Date.now;
/**
   * The base implementation of `setToString` without support for hot loop shorting.
   *
   * @private
   * @param {Function} func The function to modify.
   * @param {Function} string The `toString` result.
   * @returns {Function} Returns `func`.
   */var cr=
/**
   * Creates a function that'll short out and invoke `identity` instead
   * of `func` when it's called `HOT_COUNT` or more times in `HOT_SPAN`
   * milliseconds.
   *
   * @private
   * @param {Function} func The function to restrict.
   * @returns {Function} Returns the new shortable function.
   */
function(t){var e=0,n=0;return function(){var r=ar(),o=16-(r-n);if(n=r,o>0){if(++e>=800)return arguments[0]}else e=0;return t.apply(void 0,arguments)}}(ir);
/**
   * Sets the `toString` method of `func` to return `string`.
   *
   * @private
   * @param {Function} func The function to modify.
   * @param {Function} string The `toString` result.
   * @returns {Function} Returns `func`.
   */var ur=
/**
   * The base implementation of `_.rest` which doesn't validate or coerce arguments.
   *
   * @private
   * @param {Function} func The function to apply a rest parameter to.
   * @param {number} [start=func.length-1] The start position of the rest parameter.
   * @returns {Function} Returns the new function.
   */
function(t,e){return cr(rr(t,e,en),t+"")};
/**
   * Checks if the given arguments are from an iteratee call.
   *
   * @private
   * @param {*} value The potential iteratee value argument.
   * @param {*} index The potential iteratee index or key argument.
   * @param {*} object The potential iteratee object argument.
   * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
   *  else `false`.
   */var sr=function(t,e,n){if(!T(n))return!1;var o=typeof e;return!!("number"==o?le(n)&&Jt(e,n.length):"string"==o&&e in n)&&r(n[e],t)},lr=Object.prototype,fr=lr.hasOwnProperty,vr=ur((function(t,e){t=Object(t);var n=-1,o=e.length,i=o>2?e[2]:void 0;for(i&&sr(e[0],e[1],i)&&(o=1);++n<o;)for(var a=e[n],c=mn(a),u=-1,s=c.length;++u<s;){var l=c[u],f=t[l];(void 0===f||r(f,lr[l])&&!fr.call(t,l))&&(t[l]=a[l])}return t})),hr=Math.floor,pr=Math.min;
/** Used for built-in method references. */var dr=
/**
   * The base implementation of `_.sortedIndexBy` and `_.sortedLastIndexBy`
   * which invokes `iteratee` for `value` and each element of `array` to compute
   * their sort ranking. The iteratee is invoked with one argument; (value).
   *
   * @private
   * @param {Array} array The sorted array to inspect.
   * @param {*} value The value to evaluate.
   * @param {Function} iteratee The iteratee invoked per element.
   * @param {boolean} [retHighest] Specify returning the highest qualified index.
   * @returns {number} Returns the index at which `value` should be inserted
   *  into `array`.
   */
function(t,e,n,r){e=n(e);for(var o=0,i=null==t?0:t.length,a=e!=e,c=null===e,u=ze(e),s=void 0===e;o<i;){var l=hr((o+i)/2),f=n(t[l]),v=void 0!==f,h=null===f,p=f==f,d=ze(f);if(a)var g=r||p;else g=s?p&&(r||v):c?p&&v&&(r||!h):u?p&&v&&!h&&(r||!d):!h&&!d&&(r?f<=e:f<e);g?o=l+1:i=l}return pr(i,4294967294)};
/** Used as references for the maximum length and index of an array. */var gr=
/**
   * The base implementation of `_.sortedIndex` and `_.sortedLastIndex` which
   * performs a binary search of `array` to determine the index at which `value`
   * should be inserted into `array` in order to maintain its sort order.
   *
   * @private
   * @param {Array} array The sorted array to inspect.
   * @param {*} value The value to evaluate.
   * @param {boolean} [retHighest] Specify returning the highest qualified index.
   * @returns {number} Returns the index at which `value` should be inserted
   *  into `array`.
   */
function(t,e,n){var r=0,o=null==t?r:t.length;if("number"==typeof e&&e==e&&o<=2147483647){for(;r<o;){var i=r+o>>>1,a=t[i];null!==a&&!ze(a)&&(n?a<=e:a<e)?r=i+1:o=i}return o}return dr(t,e,en,n)};
/**
   * Uses a binary search to determine the lowest index at which `value`
   * should be inserted into `array` in order to maintain its sort order.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Array
   * @param {Array} array The sorted array to inspect.
   * @param {*} value The value to evaluate.
   * @returns {number} Returns the index at which `value` should be inserted
   *  into `array`.
   * @example
   *
   * _.sortedIndex([30, 50], 40);
   * // => 1
   */var br,yr=function(t,e){return gr(t,e)};!function(e){var n;function r(t){n=null,t&&t.off("changes",r)}function o(t,e,o){if(o)return r(),t.getTokenAt(e,o);var i=function(t,e){if(!n||!n.tokens||n.line!==e||n.cm!==t){var o=t.getLineTokens(e,!1);o.unshift(t.getTokenAt({line:e,ch:0},!1)),n={cm:t,line:e,timeStamp:Date.now(),tokens:o},t.off("changes",r),t.on("changes",r)}return n.tokens}(t,e.line);return i[yr(i,{end:e.ch})]||t.getTokenAt(e,o)}e.getTokenAt=o,e.getInitialContext=function(t,e){return{editor:t,pos:e,token:t.getTokenAt(e,!0)}},e.movePrevToken=function(t,e){if(void 0===e&&(e=!0),t.pos.ch<=0||t.token.start<=0){if(t.pos.line<=0)return!1;t.pos.line--,t.pos.ch=t.editor.getLine(t.pos.line).length}else t.pos.ch=t.token.start;return t.token=o(t.editor,t.pos,e),!0},e.isAtStart=function(t){return(t.pos.ch<=0||t.token.start<=0)&&t.pos.line<=0},e.moveNextToken=function(t,e){var n=t.editor.getLine(t.pos.line).length;if(void 0===e&&(e=!0),t.pos.ch>=n||t.token.end>=n){if(t.pos.line>=t.editor.lineCount()-1)return!1;t.pos.line++,t.pos.ch=0}else t.pos.ch=t.token.end+1;return t.token=o(t.editor,t.pos,e),!0},e.isAtEnd=function(t){var e=t.editor.getLine(t.pos.line).length;return(t.pos.ch>=e||t.token.end>=e)&&t.pos.line>=t.editor.lineCount()-1},e.moveSkippingWhitespace=function(t,e){if(!t(e))return!1;for(;!e.token.type&&!/\S/.test(e.token.string);)if(!t(e))return!1;return!0},e.offsetInToken=function(t){var e=t.pos.ch-t.token.start;return e<0&&console.log("CodeHintUtils: _offsetInToken - Invalid context: pos not in the current token!"),e},e.getModeAt=function(e,n,r){r=r||!0;var i=e.getMode();return i.innerMode&&(i=t.innerMode(i,o(e,n,r).state).mode),{mode:i,name:"xml"===i.name?i.configuration:i.name}}}(br||(br={}));var _r=function(){function e(t){this._codeMirror=t}return e.prototype.focus=function(){this._codeMirror.focus()},e.prototype.getModeForRange=function(t,e,n){var r=this._codeMirror.getMode(),o=br.getModeAt(this._codeMirror,t),i=br.getModeAt(this._codeMirror,e);return n||r.name!==o.name?o&&i&&o.name===i.name?o:null:this._codeMirror.getOption("mode")},e.prototype.setCursorPos=function(e,n){this._codeMirror.setCursor(t.Pos(e,n))},e.prototype.indexFromPos=function(t){return this._codeMirror.indexFromPos(t)},e.prototype.setSelection=function(t,e){this.setSelections([{start:t,end:e||t}])},e.prototype.setSelections=function(t){var e=t.length-1;this._codeMirror.setSelections(t.map((function(t,n){return t.primary&&(e=n),{anchor:t.reversed?t.end:t.start,head:t.reversed?t.start:t.end}})),e,void 0)},e.prototype.convertToLineSelections=function(t,e){var n=this;vr(e=e||{},{expandEndAtStartOfLine:!1,mergeAdjacent:!0});var r,o=[];return tr(t,(function(t){var i=Yn(t);i.start.ch=0;var a=i.start.line!==i.end.line||i.start.ch!==i.end.ch;!e.expandEndAtStartOfLine&&a&&0===i.end.ch||(i.end={line:i.end.line+1,ch:0}),r&&n.posWithinRange(i.start,r.selectionForEdit.start,r.selectionForEdit.end,e.mergeAdjacent)?(r.selectionForEdit.end.line=i.end.line,r.selectionsToTrack.push(t)):(r={selectionForEdit:i,selectionsToTrack:[t]},o.push(r))})),o},e.prototype.getSelectedText=function(t){if(t)return this._codeMirror.getSelection();var e=this.getSelection();return this._codeMirror.getRange(e.start,e.end)},e.prototype._copyPos=function(e){return new t.Pos(e.line,e.ch)},e.prototype.posWithinRange=function(t,e,n,r){return e.line<=t.line&&n.line>=t.line&&(r?(e.line<t.line||e.ch<=t.ch)&&(n.line>t.line||n.ch>=t.ch):(e.line<t.line||e.ch<=t.ch)&&(n.line>t.line||n.ch>t.ch))},e.prototype.hasSelection=function(){return this._codeMirror.somethingSelected()},e.prototype._normalizeRange=function(t,e){return e.line<t.line||e.line===t.line&&e.ch<t.ch?{start:this._copyPos(e),end:this._copyPos(t),reversed:!0}:{start:this._copyPos(t),end:this._copyPos(e),reversed:!1}},e.prototype.getSelection=function(){return this._normalizeRange(this.getCursorPos(!1,"anchor"),this.getCursorPos(!1,"head"))},e.prototype.getSelections=function(){var t=this.getSelection(),e=this;return ln(this._codeMirror.listSelections(),(function(n){var r=e._normalizeRange(n.anchor,n.head);return r.start.line===t.start.line&&r.start.ch===t.start.ch&&r.end.line===t.end.line&&r.end.ch===t.end.ch?r.primary=!0:r.primary=!1,r}))},e.prototype.getCursorPos=function(t,e){"start"===e?e="from":"end"===e&&(e="to");var n=this._copyPos(this._codeMirror.getCursor(e));return t&&(n.ch=this.getColOffset(n)),n},e.prototype.getColOffset=function(t){var n,r=this._codeMirror.getRange({line:t.line,ch:0},t),o=null,i=0;for(n=0;n<r.length;n++)"\t"===r[n]?(null===o&&(o=e.getTabSize()),o>0&&(i+=o-i%o)):i++;return i},e.getTabSize=function(){return 4},e.prototype.getText=function(){return this._codeMirror.getValue()},e.prototype.setText=function(t){this._codeMirror.setValue(t)},e}(),jr=Math.floor;
/** Used as references for various `Number` constants. */var mr=
/**
   * The base implementation of `_.repeat` which doesn't coerce arguments.
   *
   * @private
   * @param {string} string The string to repeat.
   * @param {number} n The number of times to repeat the string.
   * @returns {string} Returns the repeated string.
   */
function(t,e){var n="";if(!t||e<1||e>9007199254740991)return n;// Leverage the exponentiation by squaring algorithm for a faster repeat.
// See https://en.wikipedia.org/wiki/Exponentiation_by_squaring for more details.
do{e%2&&(n+=t),(e=jr(e/2))&&(t+=t)}while(e);return n},kr=/^\s+|\s+$/g,Or=/^[-+]0x[0-9a-f]+$/i,wr=/^0b[01]+$/i,xr=/^0o[0-7]+$/i,Ar=parseInt;
/** Used as references for various `Number` constants. */var Mr=
/**
   * Converts `value` to a number.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to process.
   * @returns {number} Returns the number.
   * @example
   *
   * _.toNumber(3.2);
   * // => 3.2
   *
   * _.toNumber(Number.MIN_VALUE);
   * // => 5e-324
   *
   * _.toNumber(Infinity);
   * // => Infinity
   *
   * _.toNumber('3.2');
   * // => 3.2
   */
function(t){if("number"==typeof t)return t;if(ze(t))return NaN;if(T(t)){var e="function"==typeof t.valueOf?t.valueOf():t;t=T(e)?e+"":e}if("string"!=typeof t)return 0===t?t:+t;t=t.replace(kr,"");var n=wr.test(t);return n||xr.test(t)?Ar(t.slice(2),n?2:8):Or.test(t)?NaN:+t};
/** Used as references for various `Number` constants. */var Sr=
/**
   * Converts `value` to a finite number.
   *
   * @static
   * @memberOf _
   * @since 4.12.0
   * @category Lang
   * @param {*} value The value to convert.
   * @returns {number} Returns the converted number.
   * @example
   *
   * _.toFinite(3.2);
   * // => 3.2
   *
   * _.toFinite(Number.MIN_VALUE);
   * // => 5e-324
   *
   * _.toFinite(Infinity);
   * // => 1.7976931348623157e+308
   *
   * _.toFinite('3.2');
   * // => 3.2
   */
function(t){return t?(t=Mr(t))===1/0||t===-1/0?17976931348623157e292*(t<0?-1:1):t==t?t:0:0===t?t:0};
/**
   * Converts `value` to an integer.
   *
   * **Note:** This method is loosely based on
   * [`ToInteger`](http://www.ecma-international.org/ecma-262/7.0/#sec-tointeger).
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to convert.
   * @returns {number} Returns the converted integer.
   * @example
   *
   * _.toInteger(3.2);
   * // => 3
   *
   * _.toInteger(Number.MIN_VALUE);
   * // => 0
   *
   * _.toInteger(Infinity);
   * // => 1.7976931348623157e+308
   *
   * _.toInteger('3.2');
   * // => 3
   */var Pr=function(t){var e=Sr(t),n=e%1;return e==e?n?e-n:e:0};
/**
   * Repeats the given string `n` times.
   *
   * @static
   * @memberOf _
   * @since 3.0.0
   * @category String
   * @param {string} [string=''] The string to repeat.
   * @param {number} [n=1] The number of times to repeat the string.
   * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
   * @returns {string} Returns the repeated string.
   * @example
   *
   * _.repeat('*', 3);
   * // => '***'
   *
   * _.repeat('abc', 2);
   * // => 'abcabc'
   *
   * _.repeat('abc', 0);
   * // => ''
   */var Er=function(t,e,n){return e=(n?sr(t,e,n):void 0===e)?1:Pr(e),mr(Ge(t),e)},Tr=/[\\^$.*+?()[\]{}|]/g,Cr=RegExp(Tr.source);
/**
   * Used to match `RegExp`
   * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
   */var Fr=
/**
   * Escapes the `RegExp` special characters "^", "$", "\", ".", "*", "+",
   * "?", "(", ")", "[", "]", "{", "}", and "|" in `string`.
   *
   * @static
   * @memberOf _
   * @since 3.0.0
   * @category String
   * @param {string} [string=''] The string to escape.
   * @returns {string} Returns the escaped string.
   * @example
   *
   * _.escapeRegExp('[lodash](https://lodash.com/)');
   * // => '\[lodash\]\(https://lodash\.com/\)'
   */
function(t){return(t=Ge(t))&&Cr.test(t)?t.replace(Tr,"\\$&"):t},zr=m?m.isConcatSpreadable:void 0;
/** Built-in value references. */var Lr=
/**
   * Checks if `value` is a flattenable `arguments` object or array.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is flattenable, else `false`.
   */
function(t){return Tt(t)||Vt(t)||!!(zr&&t&&t[zr])};
/**
   * The base implementation of `_.flatten` with support for restricting flattening.
   *
   * @private
   * @param {Array} array The array to flatten.
   * @param {number} depth The maximum recursion depth.
   * @param {boolean} [predicate=isFlattenable] The function invoked per iteration.
   * @param {boolean} [isStrict] Restrict to values that pass `predicate` checks.
   * @param {Array} [result=[]] The initial result value.
   * @returns {Array} Returns the new flattened array.
   */var Ir=function t(e,n,r,o,i){var a=-1,c=e.length;for(r||(r=Lr),i||(i=[]);++a<c;){var u=e[a];n>0&&r(u)?n>1?
// Recursively flatten arrays (susceptible to call stack limits).
t(u,n-1,r,o,i):Et(i,u):o||(i[i.length]=u)}return i};
/**
   * Flattens `array` a single level deep.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Array
   * @param {Array} array The array to flatten.
   * @returns {Array} Returns the new flattened array.
   * @example
   *
   * _.flatten([1, [2, [3, [4]], 5]]);
   * // => [1, 2, [3, [4]], 5]
   */var Rr,$r=function(t){return(null==t?0:t.length)?Ir(t,1):[]};!function(e){function n(e,n,r,o){var i={text:n,from:r,to:o};if(t.cmpPos(e,r)<0)return e;if(t.cmpPos(e,o)<=0)return t.changeEnd(i);var a=e.line+i.text.length-(i.to.line-i.from.line)-1,c=e.ch;return e.line===i.to.line&&(c+=t.changeEnd(i).ch-i.to.ch),{line:a,ch:c}}function r(t,e){Array.isArray(t)?tr(t,e):e(t,0)}e.doMultipleEdits=function(e,o,i){o.sort((function(e,n){var r=Array.isArray(e.edit)?e.edit[0]:e.edit,o=Array.isArray(n.edit)?n.edit[0]:n.edit;return r?o?t.cmpPos(o.start,r.start):1:-1}));var a=Yn(ln(o,"selection"));return tr(o,(function(e,n){r(e.edit,(function(e){e&&(e.end||(e.end=e.start),n>0&&r(o[n-1].edit,(function(n){if(t.cmpPos(e.end,n.start)>0)throw new Error("doMultipleEdits(): Overlapping edits specified")})))}))})),e._codeMirror.operation((function(){tr(o,(function(t,o){r(t.edit,(function(t){if(t){e._codeMirror.replaceRange(t.text,t.start,t.end,i);var c=t.text.split("\n");tr(a,(function(e,i){e&&r(e,(function(e){(e.isBeforeEdit||i!==o)&&(e.start=n(e.start,c,t.start,t.end),e.end=n(e.end,c,t.start,t.end))}))}))}}))}))})),a=a.filter((function(t){return void 0!==t})),a=(a=$r(a)).sort((function(e,n){return t.cmpPos(e.start,n.start)})),tr(a,(function(t){delete t.isBeforeEdit})),a}}(Rr||(Rr={}));var Br=/[^\s\u00a0]/;function Wr(t,e){var n=t.getMode();return!1!==n.useInnerComments&&n.innerMode?t.getModeAt(e):n}function Ur(t,e){for(var n,r,o=[],i="",a=t.length;a<e.length;a++)n=e.charAt(a),r=Fr(n),o.push(i+"[^"+r+"]"),i&&o.push(i+"$"),i+=r;return new RegExp("^\\s*"+Fr(t)+"($|"+o.join("|")+")")}function Nr(t,e,n){var r,o,i=[];return t.forEach((function(t){r=Fr(t),o=!0,e&&0===e.indexOf(t)&&(i.push(Ur(t,e)),o=!1),n&&e!==n&&0===n.indexOf(t)&&(i.push(Ur(t,n)),o=!1),o&&i.push(new RegExp("^\\s*"+r))})),i}function Dr(t,e){return e.some((function(e){return t.match(e)}))}function Vr(t,e,n){var r=null;return e.forEach((function(e,o){t.match(e)&&(r&&r.length<n[o].length||!r)&&(r=n[o])})),r}function qr(t,e,n,r){for(var o=!1,i=e;i<=n;i++){var a=t._codeMirror.getLine(i);if(a.match(/\S/)&&!Dr(a,r)){o=!0;break}}return o}function Gr(t,e,n,r,o,i){for(var a=br.moveSkippingWhitespace(br.movePrevToken,t);a&&Dr(t.token.string,i);)a=br.moveSkippingWhitespace(br.movePrevToken,t);return!(!a||"comment"!==t.token.type)&&(!t.token.string.match(r)&&!t.token.string.match(o)||(e===n&&t.token.string.length===e.length?!Gr(t,e,n,r,o,i):t.token.string.match(r)))}function Hr(t){return null==t?0:t.search(Br)}function Jr(e,n,r,o,i,a,c,u){var s,l=br.getInitialContext(e._codeMirror,{line:i.start.line,ch:i.start.ch}),f=e.indexFromPos(i.end),v=Nr(o,n,r),h=new RegExp("^"+Fr(n),"g"),p=new RegExp(Fr(r)+"$","g"),d=null,g=null,b=!0,y=!1,_=!1,j=!1,m=!1,k=!0,O=[],w=u.indent;function x(){return w&&"line"===c}for(a||(a=[Yn(i)]),l.token.type||/\S/.test(l.token.string)||(k=br.moveSkippingWhitespace(br.moveNextToken,l));k&&"comment"!==l.token.type;)k=br.moveSkippingWhitespace(br.moveNextToken,l)&&e.indexFromPos(l.pos)<=f,b=!1;if(k&&"comment"===l.token.type){if(Dr(l.token.string,v))if(0===l.token.start&&!l.token.string.match(/^\\s*/)&&b)y=Gr(br.getInitialContext(e._codeMirror,{line:l.pos.line,ch:l.token.start}),n,r,h,p,v);else y=!1;else if(y=!0,l.token.string===n&&n===r)Gr(br.getInitialContext(e._codeMirror,{line:l.pos.line,ch:l.token.start}),n,r,h,p,v)?br.moveSkippingWhitespace(br.movePrevToken,l):br.moveSkippingWhitespace(br.moveNextToken,l);if(y){var A=Yn(l.pos);for(k=!0;k&&!l.token.string.match(h);)k=br.moveSkippingWhitespace(br.movePrevToken,l);for(d=k&&{line:l.pos.line,ch:l.token.start},l.token.string===n&&n===r&&(l=br.getInitialContext(e._codeMirror,Yn(A)));k&&!l.token.string.match(p);)k=br.moveSkippingWhitespace(br.moveNextToken,l);g=k&&{line:l.pos.line,ch:l.token.end-r.length};do{k=br.moveSkippingWhitespace(br.moveNextToken,l)&&e.indexFromPos(l.pos)<=f}while(k&&!l.token.string.match(h));j=k&&!!l.token.string.match(h);var M=g&&{line:g.line,ch:g.ch+r.length};(M&&t.cmpPos(i.start,M)>0||d&&t.cmpPos(i.end,d)<0)&&(_=!0)}else{var S=i.end.line;0===i.end.ch&&e.hasSelection()&&S--,qr(e,i.start.line,S,v)?_=!0:m=!0}}else _=!0;if(j)s={edit:[],selection:a};else if(m)s=null;else{var P=u.padding?u.padding:"";if(_){var E=0===i.start.ch&&0===i.end.ch&&i.start.line<i.end.line,T=Hr(e._codeMirror.getLine(i.start.line));if(E)if(x()){var C=Hr(e._codeMirror.getLine(i.end.line-1)),F=e._codeMirror.getOption("indentWithTabs")?"\t":" ";O.push({text:Er(F,C)+r+"\n",start:{line:i.end.line,ch:0}}),O.push({text:n+"\n"+Er(F,T),start:{line:i.start.line,ch:T}})}else O.push({text:r+"\n",start:i.end}),O.push({text:n+"\n",start:i.start});else O.push({text:P+r,start:i.end}),x()?O.push({text:n+P,start:{line:i.start.line,ch:T}}):O.push({text:n+P,start:i.start});tr(a,(function(e){function o(e){t.cmpPos(e,i.end)>0&&(E?e.line++:e.line===i.end.line&&(e.ch+=r.length+2*P.length)),t.cmpPos(e,i.start)>=0&&(E?e.line++:e.line!==i.start.line||x()&&e.ch<T||(e.ch+=n.length+P.length))}o(e.start),o(e.end)}))}else{var z=e._codeMirror.getLine(d.line),L=z.trim(),I=0===d.ch&&n.length===L.length,R=w&&n.length===L.length,$=(S="",!1),B=!1;if(g){var W=(S=e._codeMirror.getLine(g.line)).trim();$=0===g.ch&&r.length===W.length,B=w&&r.length===W.length}if(g)if(B)O.push({text:"",start:{line:g.line,ch:0},end:{line:g.line+1,ch:0}});else if(I&&$)O.push({text:"",start:g,end:{line:g.line+1,ch:0}});else{var U=P&&S.slice(g.ch-P.length,g.ch)===P?P.length:0;O.push({text:"",start:{line:g.line,ch:g.ch-U},end:{line:g.line,ch:g.ch+r.length}})}if(R)O.push({text:"",start:{line:d.line,ch:0},end:{line:d.line+1,ch:0}});else if(I&&$)O.push({text:"",start:d,end:{line:d.line+1,ch:0}});else{var N=d.ch+n.length;P&&z.slice(N,N+P.length)===P&&(N+=P.length),O.push({text:"",start:d,end:{line:d.line,ch:N}})}tr(a,(function(t){t.isBeforeEdit=!0}))}s={edit:O,selection:a}}return s}function Kr(t,e){return t?Array.isArray(t)?t.length>0?t:e:[t]:e}function Qr(e,n,r,o){var i=e.convertToLineSelections(n,{mergeAdjacent:!1}),a=[];return tr(i,(function(n){var i,c=n.selectionForEdit,u=e.getModeForRange(c.start,c.end);if(u){var s=o.getMode?o.getMode(u,c.start):Wr(e._codeMirror,c.start),l=Kr(o.lineComment||s.lineComment,null),f=o.blockCommentStart||s.blockCommentStart,v=o.blockCommentEnd||s.blockCommentEnd;l?i=function(e,n,r,o,i,a){var c=i.selectionForEdit,u=i.selectionsToTrack,s=Nr(n,r,o),l=c.start.line,f=c.end.line,v=[];0===c.end.ch&&f--;var h=qr(e,l,f,s),p=null!==a.padding&&void 0!==a.padding?a.padding:" ",d=a.commentBlankLines;if(h){var g=n[0]+p,b=null;if(a.indent){for(var y=l;y<=f;y++){var _=Hr(O=e._codeMirror.getLine(y));if(0!==O.length&&-1!==_){var j=O.slice(0,_);(null===b||b.length>j.length)&&(b=j)}}b=null===b?"":b;for(y=l;y<=f;y++){_=Hr(O=e._codeMirror.getLine(y));if(d||-1!==_){var m=void 0;if(-1===_)0===O.length?(m=b+g,v.push({text:m,start:{line:y,ch:0}})):O.length===b.length?(m=g,v.push({text:m,start:{line:y,ch:O.length}})):O.length>b.length?(m=g,v.push({text:m,start:{line:y,ch:b.length}})):(m=b+g,v.push({text:m,start:{line:y,ch:0}}));else{m=g;var k=b.length;O.slice(0,k)!==b&&(k=_),v.push({text:m,start:{line:y,ch:k}})}}}}else for(y=l;y<=f;y++)(d||Br.test(e._codeMirror.getLine(y)))&&v.push({text:g,start:{line:y,ch:0}});tr(u,(function(e){0===e.start.ch&&0!==t.cmpPos(e.start,e.end)?(e.start={line:e.start.line,ch:0},e.end={line:e.end.line,ch:e.end.line===f?e.end.ch+g.length:0}):e.isBeforeEdit=!0}))}else{for(y=l;y<=f;y++){var O,w=Vr(O=e._codeMirror.getLine(y),s,n);if(w){var x=O.indexOf(w),A=x+w.length;O.slice(A,A+p.length)===p&&(A+=p.length),v.push({text:"",start:{line:y,ch:x},end:{line:y,ch:A}})}}tr(u,(function(t){t.isBeforeEdit=!0}))}return{edit:v,selection:u}}(e,l,f,v,n,o):(f||v)&&(i=function(t,e,n,r,o,i){var a=r.selectionForEdit;return a.end.line===a.start.line+1&&0===a.end.ch&&(a.end={line:a.start.line,ch:t._codeMirror.getLine(a.start.line).length}),Jr(t,e,n,[],a,r.selectionsToTrack,o,i)}(e,f,v,n,r,o))}i||(i={selection:n.selectionsToTrack}),a.push(i)})),a}t.defineExtension("toggleLineComment",(function(t){void 0===t&&(t={}),function(t,e){t.setSelections(Rr.doMultipleEdits(t,Qr(t,t.getSelections(),"line",e)))}(new _r(this),t)})),t.defineExtension("toggleBlockComment",(function(t){void 0===t&&(t={}),function(t,e){var n=[],r=[];tr(t.getSelections(),(function(o){var i=t.getModeForRange(o.start,o.end),a={edit:[],selection:[o]};if(i){var c=e.getMode?e.getMode(i,o.start):Wr(t._codeMirror,o.start),u=Kr(e.lineComment||c.lineComment,[]),s=e.blockCommentStart||c.blockCommentStart,l=e.blockCommentEnd||c.blockCommentEnd;(s||l)&&((a=Jr(t,s,l,u,o,null,"block",e))||r.push(o))}a&&n.push(a)})),n.push.apply(n,Qr(t,r,"block",e)),t.setSelections(Rr.doMultipleEdits(t,n))}(new _r(this),t)}))}));
